<template>
  <div>
    <div class="pod-number">
      <span>{{ podMainInfo.podNumber }}</span>
      <span class="pod-number__status">{{ titlePodStatus }}</span>
    </div>
    <div class="confirmation-execution-statistic">
      <div class="confirmation-execution-statistic-block">
        <div class="confirmation-execution-statistic-block--left">
          <span>Всего документов в POD:</span>
          <span>Отправлено заказчику:</span>
          <span>Получено заказчиком:</span>
        </div>
        <div>
          <span>{{ podDocuments.length }}</span>
          <span>{{ podMainInfo.sentCount || 0 }}</span>
          <span>{{ podMainInfo.acceptedCount || 0 }}</span>
        </div>
      </div>
      <div class="confirmation-execution-statistic-block">
        <div class="confirmation-execution-statistic-block--left">
          <span>Плановая дата отправки POD заказчику:</span>
          <span>Фактическая дата отправки POD заказчику:</span>
          <span>Фактическая дата получения POD заказчиком:</span>
        </div>
        <div>
          <span>{{ podMainInfo.sendPlanD | date }}</span>
          <span>{{ podMainInfo.sentD | date }}</span>
          <span>{{ currentOrder.receivingDate | date }}</span>
        </div>
      </div>
      <div
        v-if="!isCanceled && isShowConfirmButton"
        class="confirmation-execution-statistic-button"
      >
        <ObButton
          label="Подтвердить исполнение"
          :disabled="currentStatus !== 'PROCESSED' || disabledConfirm"
          @click="confirmProcess"
        />
      </div>
      <div
        v-if="!isCanceled && isShowConfirmSendDocsButton"
        class="confirmation-execution-statistic-button"
      >
        <ObButton
          label="Подтвердить отправку бумажных документов"
          @click="confirmSendDocsProcess"
          :disabled="disabledConfirmDocs"
        />
      </div>
      <ObModal
        ref="confirmModal"
        title="Подтверждение исполнения"
        size="md"
      >
        <ConfirmModal
          :order="currentOrder"
          :docs-count="podDocuments.length"
          @on-submit="confirm"
        />
      </ObModal>
      <ObModal
        ref="confirmSendDocsModal"
        title="Подтверждение отправки бумажых документов"
        size="md"
      >
        <ConfirmSendDocsModal
          :pod-documents="podDocuments"
          @on-submit="confirmSendDocs"
        />
      </ObModal>
    </div>
  </div>
</template>

<script>
  import { mapActions, mapGetters } from 'vuex'
  import ObButton from 'common-components/src/obComponents/obButton'
  import ObModal from 'common-components/src/obComponents/obModal'
  import ConfirmModal from './confirmModal'
  import ConfirmSendDocsModal from './confirmSendDocsModal'

  export default {
    name: "statistic",
    props: {
      order: {
        type: Object,
        default: () => {}
      }
    },
    data () {
      return {
        disabledConfirm: false,
        disabledConfirmDocs: false
      }
    },
    components: {
      ObButton,
      ObModal,
      ConfirmModal,
      ConfirmSendDocsModal
    },
    computed: {
      ...mapGetters({
        firstOrder: 'order/order',
        selectedSubOrder: 'order/selectedSubOrder',
        subOrder: 'order/subOrder',
        isCarrier: 'user/isCarrier',
        isClicar: 'user/isClicar',
        isClient: 'user/isClient',
        podsInfo: 'order/podsInfo'
      }),
      currentOrder () {
        if (this.selectedSubOrder) {
          return this.subOrder[this.selectedSubOrder.uuid] || {}
        } else  {
          return this.firstOrder
        }
      },
      currentStatus () {
        return this.currentOrder && this.currentOrder.status
      },
      isShowConfirmButton () {
        if (this.order.isSuborder) {
          return this.isClicar
        }

        return this.isClicar || this.isClient
      },
      isShowConfirmSendDocsButton () {
        if (this.order.isSuborder) {
          return this.isCarrier && this.podMainInfo.podStatus === 'NEW'
        } else {
          return this.isClicar && this.podMainInfo.podStatus === 'NEW'
        }
      },
      isCanceled () {
        return this.currentStatus === 'CANCELED'
      },
      podUuid () {
        return this.order.podUuid
      },
      podInfo () {
        return this.podUuid ? this.podsInfo[this.podUuid] || {} : {}
      },
      podDocuments () {
        return this.podInfo.documents || []
      },
      podMainInfo () {
        return this.podInfo.main || {}
      },
      titlePodStatus () {
        const titleMap = {
          NEW: 'ФОРМИРОВАНИЕ',
          SENT: 'ОТПРАВЛЕН КОНТРАГЕНТУ'
        }

        return titleMap[this.podMainInfo.podStatus] || ''
      }
    },
    methods: {
      ...mapActions({
        confirmOrder: 'order/confirmOrder',
        confirmSubOrder: 'order/confirmSubOrder',
        confirmationDispatchPod: 'order/confirmationDispatchPod',
        getOrder: 'order/getOrder'
      }),
      async confirm (data) {
        try {
          this.disabledConfirm = true
          if (this.selectedSubOrder) {
            await this.confirmSubOrder({ subOrder: this.selectedSubOrder, data })
          } else  {
            await this.confirmOrder({ uuid: this.firstOrder.uuid, data })
          }
          this.$refs.confirmModal.close()
          this.$notification({
            type: 'system_notification_success',
            message: 'Исполнение заказа подтверждено'
          })
        } catch (e) {
          this.disabledConfirm = false
          this.$notification({
            type: 'system_notification_error',
            message: 'Не удалось подтвердить исполнение'
          })
        }
      },
      async confirmSendDocs (data) {
        try {
          this.disabledConfirmDocs = true
          this.confirmationDispatchPod({ orderData: this.currentOrder, data: { uuid: this.podUuid, ...data } })
          this.$refs.confirmSendDocsModal.close()
          this.$notification({
            type: 'system_notification_success',
            message: 'Отправка бумажных документов подтверждена'
          })
        } catch (e) {
          this.disabledConfirmDocs = false
          this.$notification({
            type: 'system_notification_error',
            message: 'Не удалось подтвердить отправку документов'
          })
        }
      },
      confirmProcess () {
        this.$refs.confirmModal.open()
      },
      confirmSendDocsProcess () {
        this.$refs.confirmSendDocsModal.open()
      }
    }
  }
</script>

<style scoped lang="scss">
  @import "~common-components/src/static/css/mixins";

  .confirmation-execution-statistic {
    margin-top: 15px;
    min-height: 176px;
    padding: 20px;
    background: $background-white ;
    border: 1px solid $lavender;
    border-radius: 3px;
    display: flex;
    flex-wrap: wrap;
    &-block {
      display: flex;
      font-size: 14px;
      line-height: 24px;
      color: $color-text-base;
      flex-grow: 1;
      width: 50%;
      div > span {
        display: block;
      }
      &--left {
        text-align: right;
        margin-right: 20px;
        color: $color-grey-span;
      }
    }
    &-button {
      width: 100%;
      margin-top: 24px;
    }
    &-button + .confirmation-execution-statistic-button {
      margin-top: 10px;
    }
  }

  .pod-number {
    margin-top: 7px;
    @include font-mixin(20px, 28px, 700, $color-blue-navy-blue, 0.4px);
    &__status {
      position: relative;
      top: -10px;
      margin-left: 8px;
      @include font-mixin(10px, 20px, 400, $gray-slate, 0.4px, uppercase);
    }
  }
</style>
